FUNCTION F_W_3 ( S, FA )

  USE GLOBAL, ONLY: WP, W0, PI, M
  USE MSIMSL

  IMPLICIT NONE 

!----------------------------------------------------------------------

  REAL(WP), PARAMETER  :: PI14 =  0.7511255444649
  REAL(WP), INTENT(IN) :: S, FA
  COMPLEX(WP)          :: F_W_3

!----------------------------------------------------------------------
 
    F_W_3 = (CMPLX(0.,1.)**M)/SQRT(GAMMA(REAL(M)+0.5))                 &
                  * (S*2.*PI*FA)**M                                    &
                  * EXP(-(S*2.*PI*FA)*(S*2.*PI*FA)/2.)

END FUNCTION F_W_3