PROGRAM RCWT

  USE GLOBAL, ONLY: WV, WVT, WVD, TTT, FFF, N, K1, K2, K3, K4, WVLT_TYPE

  IMPLICIT NONE

!----------------------------------------------------------------------

  CALL READ_INP_PARAM 
  CALL READ_INP_DATA
  CALL WRITE_PAR

  CALL FFT_DATA
  CALL CWT

  IF  ( (WVLT_TYPE==1) .AND. (K1.OR.K2.OR.K3)) THEN 
    CALL CWT_T

    CALL CWT_D

    WHERE ( ABS(WV) > 0. )
      TTT = REAL ( WVT(1:N,:) / WV (1:N,:) )
      FFF = REAL ( WVD(1:N,:) / WV (1:N,:) )
    ELSEWHERE
      TTT = 0.
      FFF = 0.
    END WHERE
  ENDIF

  CALL WRITE_RES

END PROGRAM RCWT
