SUBROUTINE WRITE_PAR

  USE GLOBAL, ONLY: WV, N, DT, TB, TE, OFMAX, FMIN, FMAX,          &
                    V, WVLT_TYPE, M, W0, KEY_LOG, K1, K2, K3, K4,  &
                    OUTr_FILE, OUTt_FILE, OUTf_FILE, OUTo_FILE, TFA 

  IMPLICIT NONE

!--------------------------------------------------------------------

  TFA = 'CWT'
  
  IF ( K1.AND.(WVLT_TYPE==1) ) THEN 
    OPEN  ( 12, FILE=OUTr_FILE, FORM='UNFORMATTED',STATUS="NEW" )
    WRITE ( 12 ) TFA
    WRITE ( 12 ) WVLT_TYPE

    SELECT CASE ( WVLT_TYPE )
      CASE (1)
        WRITE ( 12 ) W0
      CASE (2)
        WRITE ( 12 ) M
      CASE (3)
        WRITE ( 12 ) M
    END SELECT 
   
    WRITE ( 12 ) N, DT, TB, TE, FMIN, FMAX, OFMAX, KEY_LOG
    WRITE ( 12 ) V(1:N)
  ENDIF

  IF ( K2.AND.(WVLT_TYPE==1) ) THEN
    OPEN  ( 14, FILE=OUTt_FILE, FORM='UNFORMATTED',STATUS="NEW" )
    WRITE ( 14 ) TFA
    WRITE ( 14 ) WVLT_TYPE

    SELECT CASE ( WVLT_TYPE )
      CASE (1)
        WRITE ( 14 ) W0
      CASE (2)
        WRITE ( 14 ) M 
      CASE (3)
        WRITE ( 14 ) M
    END SELECT 

    WRITE ( 14 ) N, DT, TB, TE, FMIN, FMAX, OFMAX, KEY_LOG
    WRITE ( 14 ) V(1:N)
  ENDIF

  IF ( K3.AND.(WVLT_TYPE==1) ) THEN
    OPEN  ( 15, FILE=OUTf_FILE, FORM='UNFORMATTED',STATUS="NEW" )
    WRITE ( 15 ) TFA
    WRITE ( 15 ) WVLT_TYPE

    SELECT CASE ( WVLT_TYPE )
      CASE (1)
        WRITE ( 15 ) W0
      CASE (2)
        WRITE ( 15 ) M
      CASE (3)
        WRITE ( 15 ) M
    END SELECT 

    WRITE ( 15 ) N, DT, TB, TE, FMIN, FMAX, OFMAX, KEY_LOG
    WRITE ( 15 ) V(1:N)
  ENDIF

  IF ( K4 ) THEN
  OPEN  ( 16, FILE=OUTo_FILE, FORM='UNFORMATTED',STATUS="NEW" )
    WRITE ( 16 ) TFA
    WRITE ( 16 ) WVLT_TYPE

    SELECT CASE ( WVLT_TYPE )
      CASE (1)
        WRITE ( 16 ) W0
      CASE (2)
        WRITE ( 16 ) M
        IF ( (.NOT.KEY_LOG).AND.(FMIN==0.) ) FMIN = (FMAX-FMIN) / (OFMAX-1)  
      CASE (3)
        WRITE ( 16 ) M
        IF ( (.NOT.KEY_LOG).AND.(FMIN==0.) ) FMIN = (FMAX-FMIN) / (OFMAX-1)   
    END SELECT 

    WRITE ( 16 ) N, DT, TB, TE, FMIN, FMAX, OFMAX, KEY_LOG
    WRITE ( 16 ) V(1:N)
  ENDIF

END SUBROUTINE WRITE_PAR