SUBROUTINE WRITE_RES

  USE GLOBAL, ONLY: WP, WV, N, DT, TB, TE, OFMAX, KEY_LOG, FMINLOG,    &
                    FMAXLOG, WVT, TTT, FFF, FMAX, FMIN, K1, K2, K3, K4,&
                    WVLT_TYPE

  IMPLICIT NONE

!----------------------------------------------------------------------
  
  INTEGER :: I,K,IT,KT

!-----------------------------------------------------------------------


!--------------- reassign T and F

  IF ( K1.AND.(WVLT_TYPE==1) ) THEN
    WVT = CMPLX(0.,0.)

    DO I = 1, N
      DO K = 1, OFMAX
        IT = I + (TTT(I,K)-TB)/DT

        IF ( KEY_LOG ) THEN
          IF ( FFF(I,K) > 0.) THEN
            KT = 1 + (LOG10(FFF(I,K))-FMINLOG)*REAL(OFMAX-1,WP)/(FMAXLOG-FMINLOG)
          ELSE
            KT = -1
          ENDIF
        ELSE
          KT = 1 + (      FFF(I,K) -FMIN   )*REAL(OFMAX-1,WP)/(FMAX   -FMIN   )
        END IF
        IF ( ( IT >=1 ) .AND. ( IT <= N     ) .AND.                    &
             ( KT >=1 ) .AND. ( KT <= OFMAX )        )  THEN
          WVT(IT,KT) = WVT(IT,KT) + ABS(WV(I,K))*ABS(WV(I,K))    
        END IF
      END DO
    END DO
    
    WVT(N+1,:)=WV (N+1,:)
    DO I = 1, OFMAX
      WRITE ( 12 ) ABS(WVT(1:N+1,I))
    END DO
    CLOSE ( 12 )

  END IF
!------------- reassign only T

  IF ( K2.AND.(WVLT_TYPE==1) ) THEN
    WVT = CMPLX(0.,0.)

    DO I = 1, N
      DO K = 1, OFMAX
        IT = I + TTT(I,K)/DT
        KT = K
        IF ( ( IT >=1 ) .AND. ( IT <= N     ) .AND.                    &
             ( KT >=1 ) .AND. ( KT <= OFMAX )        )  THEN
          WVT(IT,KT) = WVT(IT,KT) + ABS(WV(I,K))*ABS(WV(I,K))
        END IF
      END DO
    END DO
    
    WVT(N+1,:)=WV (N+1,:)
    DO I = 1, OFMAX
      WRITE ( 14 ) ABS(WVT(1:N+1,I))
    END DO
    CLOSE ( 14 )

  END IF

!------------- reassign only F

  IF ( K3.AND.(WVLT_TYPE==1) ) THEN
    WVT = CMPLX(0.,0.)

    DO I = 1, N
      DO K = 1, OFMAX
        IT = I
        KT = 1 + FFF(I,K)*REAL(OFMAX-1,WP)/(FMAX-FMIN)
        IF ( ( IT >=1 ) .AND. ( IT <= N     ) .AND.                    &
             ( KT >=1 ) .AND. ( KT <= OFMAX )        )  THEN
          WVT(IT,KT) = WVT(IT,KT) + ABS(WV(I,K))*ABS(WV(I,K))
        END IF
      END DO
    END DO

    WVT(N+1,:)=WV (N+1,:)
    DO I = 1, OFMAX
      WRITE ( 15 ) ABS(WVT(1:N+1,I))
    END DO
    CLOSE ( 15 )
  END IF

!------------- original

  IF ( K4 ) THEN
    DO I = 1, OFMAX
      WV(1:N,I) = CMPLX(ABS(WV(1:N,I))*ABS(WV(1:N,I)),0.)
      WRITE ( 16 ) ABS(WV (1:N+1,I))
    END DO
    CLOSE ( 16 )
  END IF

  CLOSE (12)

END SUBROUTINE WRITE_RES