SUBROUTINE PREP_WINDOW

  USE GLOBAL, ONLY: F_V, TW_TYPE, NTW2, NTW, DT, PI, WTW, PERC

  IMPLICIT NONE 

  INTEGER :: TNTW, I

! -------------------------------------------------------------

  NTW2= WTW/DT/2.
  NTW = NTW2*2 + 1

  F_V = CMPLX(0.,0.)

  SELECT CASE ( TW_TYPE )
  CASE ( 1 )
    TNTW = NTW*PERC+1
    DO I = 1, TNTW
      F_V(I) = CMPLX( 0.5 - 0.5*COS(REAL(  I-1)/REAL(NTW*PERC)*PI), 0.)
    END DO
    F_V(TNTW+1 : NTW-TNTW) = CMPLX(1.,0.)
    DO I = NTW-TNTW+1, NTW
      F_V(I) = CMPLX( 0.5 - 0.5*COS(REAL(NTW-I)/REAL(NTW*PERC)*PI), 0.)
    END DO
  END SELECT
   

END SUBROUTINE PREP_WINDOW