SUBROUTINE READ_INP_DATA

  USE GLOBAL, ONLY: INP_FILE, TB, TE, DT, WTW, V, N, WV, WVT, WVD,     &
                    F_V, FWV,                                          &
                    FMIN, FMAX, OFMAX, PI, NFFT, FFF, TTT, KEY_LOG


  IMPLICIT NONE

  INTEGER :: I

!--------------------------------------------------------------------

  IF ( .NOT. KEY_LOG ) THEN
    OFMAX = (FMAX-FMIN)*NFFT*DT
  END IF

  ALLOCATE ( V(1:N), WV(1:N+1,1:OFMAX), WVD(1:N+1,1:OFMAX),         &
             WVT(1:N+1,1:OFMAX), F_V(NFFT), FWV (NFFT),             & 
             TTT(1:N  ,1:OFMAX), FFF(1:N ,1:OFMAX) ) 

  OPEN ( 11, FILE=INP_FILE, STATUS="OLD" )


  WV = CMPLX(0.,0.)
  WVT= CMPLX(0.,0.)
  WVD= CMPLX(0.,0.)
  TTT= 0.
  FFF= 0.

  DO I = 1, N
	  READ ( 11, * )  V(I)
  END DO
 

  CLOSE (11)


END SUBROUTINE READ_INP_DATA