SUBROUTINE WRITE_RES

  USE GLOBAL, ONLY: DP, WV, N, DT, TB, TE, OFMAX, NFFT, FFF, TTT, WVT, &
                    K1, K2, K3, K4, FMIN, FMAX, FMINLOG, FMAXLOG, KEY_LOG

  IMPLICIT NONE
  
  INTEGER :: I,K,IT,KT
  REAL(DP):: DF

!-----------------------------------------------------------------------
  
  DF = 1./(REAL(NFFT)*DT)

  WVT = CMPLX(0.,0.)

  IF ( K1 ) THEN 

    DO I = 1, N
      DO K = 1, OFMAX
        IT = 1 +  TTT(I,K)/DT
        KT = K +  FFF(I,K)/DF
        IF ( ( IT >=1 ) .AND. ( IT <= N     ) .AND.                      &
             ( KT >=1 ) .AND. ( KT <= OFMAX )        )  THEN
          WVT(IT,KT) = WVT(IT,KT) + ABS(WV(I,K))*ABS(WV(I,K))
        END IF
      END DO
    END DO

    DO K = 1, OFMAX
      WVT(N+1,K)=WV (N+1,K)
      WRITE ( 12 ) ABS(WVT(1:N+1,K))
    END DO

  END IF

    
  WVT = CMPLX(0.,0.)

  IF ( K2 ) THEN 

    DO I = 1, N
      DO K = 1, OFMAX
        IT = 1 + TTT(I,K)/DT
        KT = K
        IF ( ( IT >=1 ) .AND. ( IT <= N     ) .AND.                      &
             ( KT >=1 ) .AND. ( KT <= OFMAX )        )  THEN
          WVT(IT,KT) = WVT(IT,KT) + ABS(WV(I,K))*ABS(WV(I,K))
        END IF
      END DO
    END DO
    DO K = 1, OFMAX
      WVT(N+1,K)=WV (N+1,K)
      WRITE ( 14 ) ABS(WVT(1:N+1,K))
    END DO

  END IF


  WVT = CMPLX(0.,0.)

  IF ( K3 ) THEN 

    DO I = 1, N
      DO K = 1, OFMAX
        IT = I
        KT = K + FFF(I,K)/DF
        IF ( ( IT >=1 ) .AND. ( IT <= N     ) .AND.                      &
             ( KT >=1 ) .AND. ( KT <= OFMAX )        )  THEN
          WVT(IT,KT) = WVT(IT,KT) + ABS(WV(I,K))*ABS(WV(I,K))
        END IF
      END DO
    END DO
    DO K = 1, OFMAX
      WVT(N+1,K)=WV (N+1,K)
      WRITE ( 15 ) ABS(WVT(1:N+1,K))
    END DO

  END IF

    
  IF ( K4 ) THEN 

    DO K = 1, OFMAX
      WV(1:N,K) = ABS(WV(1:N,K))*ABS(WV(1:N,K))
      WRITE ( 16 ) ABS(WV(1:N+1,K))
    END DO

  END IF
 

END SUBROUTINE WRITE_RES