MODULE  GLOBAL

  USE PRECISION

  IMPLICIT NONE

  LOGICAL             :: KEY_LOG
!  REAL(DP), PARAMETER :: PI = 3.1415926535897932384626433832795
  REAL(DP), PARAMETER :: PI2= 6.28318530717958647692528676655901

  CHARACTER (LEN=10)  :: OUT_FILE
  CHARACTER (LEN=20)  :: INP_FILE

  INTEGER             :: N, NITER, OFMAX, DICT

  REAL (DP)           :: TB, TE, DT, FMIN, FMAX, DF

  INTEGER   ,DIMENSION (:),   ALLOCATABLE :: IDEC

  REAL (DP) ,DIMENSION (:),   ALLOCATABLE :: V
  REAL (DP) ,DIMENSION (:,:), ALLOCATABLE :: DEC, WV

  INTERFACE

    FUNCTION     EF (T, W)
      USE PRECISION, ONLY: DP
      IMPLICIT NONE
      REAL (DP), INTENT(IN) :: T, W
      REAL (DP)             :: EF
    END FUNCTION EF

    FUNCTION     WG (T, W)
      USE PRECISION, ONLY: DP
      IMPLICIT NONE
      REAL (DP), INTENT(IN) :: T, W
      REAL (DP)             :: WG
    END FUNCTION WG


  END INTERFACE

END MODULE  GLOBAL