SUBROUTINE READ_STR_BOOK

  USE GLOBAL, ONLY: DP, V, N, IDEC, DEC, NITER, DT, TB

!----------------------------------------------------------------------

  IMPLICIT NONE

  CHARACTER (LEN=10) :: TLBUF
  CHARACTER (LEN=80) :: TMPCHAR

  INTEGER      :: I, IOS
  REAL    (DP) :: TT, GG, TP, TL, TK, TM, TM3, TK_TLTP, TL_TMTP, TP_TB

!----------------------------------------------------------------------

  ALLOCATE ( IDEC(N), DEC(N,0:7) )

  OPEN ( 15, FILE = 'BOOK.ORI', STATUS = 'OLD' )
  READ ( 15, '(A)' ) TMPCHAR
  READ ( 15, '(A)' ) TMPCHAR

  NITER = 1
  DO
    READ ( UNIT = 15, IOSTAT = IOS, FMT = * )                          &
         IDEC(NITER), DEC(NITER,0), DEC(NITER,1), TP_TB,               &
                      TK_TLTP, DEC(NITER,4), DEC(NITER,5),             &
                      TL_TMTP, TM3
    TM = TM3/3.
    TP = TP_TB - TB
    TL = TL_TMTP - TM*TP
    TK = TK_TLTP - TL*TP
    IF ( IOS /= 0 ) EXIT
    IF ( IDEC(NITER) > 0 ) THEN
      DEC(NITER,1) = DEC(NITER,1)       /DT
      DEC(NITER,2) = TP / DT
      DEC(NITER,3) = TK*DT*      REAL(N,DP)
      DEC(NITER,6) = TL*DT*DT*   REAL(N,DP)
      DEC(NITER,7) = TM*DT*DT*DT*REAL(N,DP)
      WRITE ( TLBUF, '(A3, I3.3, A4)' )  'VEC', IDEC(NITER), '.DAT'
      OPEN  ( 20, FILE = TLBUF(1:10), STATUS = 'OLD' )
      DO I = 1, N
        READ ( 20, *) TT, GG
        V(I) = V(I) - GG      
      END DO
      CLOSE ( 20 )
      NITER = NITER+1
    END IF
  END DO

  CLOSE ( 15 )

  NITER = NITER - 1
      
END SUBROUTINE READ_STR_BOOK