FUNCTION FIND_KS (S)

  USE GLOBAL, ONLY: DP, N, GS

  IMPLICIT NONE

  REAL (DP), INTENT(IN) :: S
  REAL (DP)             :: FIND_KS

  INTEGER   :: I
  REAL (DP) :: SUM, TGS

  SUM = 0._DP

  IF ( NINT(S) >= 2*N ) THEN
    SUM = REAL(N,DP)
  ELSE
    DO I = 1, N
      TGS = GS(S, REAL(I,DP), 1._DP)
      SUM = SUM + TGS*TGS
    END DO
  END IF

  FIND_KS = 1._DP/SQRT(SUM)

END FUNCTION FIND_KS
