FUNCTION func(x)

  USE GLOBAL, ONLY: RV, N, INN_PROD, FIND_KS, G_GAMA, PI2, GG
  USE nrtype

  IMPLICIT NONE

  INTEGER  :: I
  REAL(SP) :: func
  REAL(SP), DIMENSION(:), INTENT(IN) :: x
  REAL(DP) :: S, P, K, L, M, KS, FI, RI, T, KGAMAFI

  COMPLEX(DP):: MAXIP

  S    = REAL ( X(1), DP )
  P    = REAL ( X(2), DP )
  K    = REAL ( X(3), DP )
  IF ( UBOUND(X,1) > 3 ) THEN
    L  = REAL ( X(4), DP )
  ELSE
    L  = 0.
  END IF
  IF ( UBOUND(X,1) > 4 ) THEN
    M  = REAL ( X(5), DP )
  ELSE
    M  = 0.
  END IF
!  print *,s,p,k,l,m
  FUNC = 0._SP

  IF ( ( NINT(S) > 2*N+10                             ) .OR.           &
       ( NINT(S) < 1                                  ) .OR.           &
       ( NINT(P) >=  N                                ) .OR.           &
       (      P  < 0._DP                              ) ) RETURN
!!       (      K  > REAL( N, DP) / 2._DP               ) .OR.           &
!!       (      K  < 0._DP                              ) ) RETURN

  IF ( ( NINT(S) >= 2*N  ) .AND.                                       &
       (      P  > 0._DP ) ) RETURN

  KS   = FIND_KS ( S )
!!!  FUNC = -REAL(ABS(INN_PROD (RV, S, P, K, L, M, KS )),SP)

  IF ( NINT(S) >= 2*N ) THEN
    DO I = 1, N
      RI = REAL(I,DP)
      T = RI-P
      GG (I) = KS * EXP( CMPLX(0._DP,PI2)*(M*T*T+L*T+K)*RI/REAL(N,DP) )
    END DO
  ELSE
    DO I = 1, N
      GG (I) = G_GAMA ( S, P, K, L, M, I, KS )
    END DO
  END IF

  MAXIP = INN_PROD (RV, GG)

  FI = ATAN2 ( IMAG(MAXIP), REAL(MAXIP) )

! vypocet K(gama,Fi)
  KGAMAFI = SQRT(   2._DP /                                          &
                  ( 1._DP + REAL ( EXP ( CMPLX (0._DP, 2._DP*FI) )   &
                          * INN_PROD (GG, CONJG(GG)), DP) ) )

! vypocet <RnF,g_gama_fi>
  FUNC = -KGAMAFI*REAL ( MAXIP * EXP ( CMPLX(0._DP,-FI) ), DP)

!  print *,func

END FUNCTION func
