FUNCTION FUNC_ALFA(GS_ALFA,P,K,L,M)

  USE GLOBAL, ONLY: RV, N, INN_PROD, FIND_KS, G_GAMA, PI2, GG
  USE nrtype

  IMPLICIT NONE

  INTEGER  :: I, IMP
  REAL(DP) :: FUNC_ALFA
  REAL(DP), INTENT(IN) :: P, K, L, M
  REAL(DP), DIMENSION(:), INTENT(IN) :: GS_ALFA
  REAL(DP)             :: FI, RI, T, KGAMAFI

  COMPLEX(DP):: MAXIP

  FUNC_ALFA = 0._SP

  DO I = 1, N
    RI  = REAL(I,DP)
    IMP = MOD(I-NINT(P)+N-1,N)+1
    T  = RI-P
    GG(I) =             CMPLX( GS_ALFA(IMP), 0._DP ) *                 &
                EXP( CMPLX(0._DP,PI2)  *                               &
                ( M*T*T + L*T + K )*RI/REAL(N,DP) )
  END DO

  MAXIP = INN_PROD (RV, GG)

  FI = ATAN2 ( IMAG(MAXIP), REAL(MAXIP) )

! vypocet K(gama,Fi)
  KGAMAFI = SQRT(   2._DP /                                          &
                  ( 1._DP + REAL ( EXP ( CMPLX (0._DP, 2._DP*FI) )   &
                          * INN_PROD (GG, CONJG(GG)), DP) ) )

! vypocet <RnF,g_gama_fi>
  FUNC_ALFA = KGAMAFI*REAL ( MAXIP * EXP ( CMPLX(0._DP,-FI) ), DP)

END FUNCTION FUNC_ALFA
