FUNCTION G_GAMA (S, P, K, L, M, I, KS)

  USE GLOBAL, ONLY: DP, PI2, N, GS

  IMPLICIT NONE

  INTEGER     , INTENT(IN) :: I
  REAL    (DP), INTENT(IN) :: S, P, KS, K, L, M
  REAL    (DP)             :: RI, T
  COMPLEX (DP)             :: G_GAMA

  RI     = REAL(I,DP)
  T      = RI-P
  G_GAMA = GS (S, T, KS)                                               &
         * EXP( CMPLX(0._DP,PI2)*(M*T*T+L*T+K)*RI/REAL(N,DP) )

END FUNCTION G_GAMA