FUNCTION INN_PROD (RV, GG)

  USE GLOBAL, ONLY: DP, N

  IMPLICIT NONE

  COMPLEX (DP), DIMENSION(:), INTENT(IN) :: RV, GG
  COMPLEX (DP)                           :: INN_PROD

  INTEGER      :: I
  REAL    (DP) :: RI, T
  COMPLEX (DP) :: SUM

  SUM = CMPLX ( 0._DP, 0._DP )

  DO I = 1, N
    SUM   = SUM + RV(I) * CONJG ( GG(I) )
  END DO

  INN_PROD = SUM

END FUNCTION INN_PROD


