SUBROUTINE READ_INP_DATA

  USE GLOBAL, ONLY: DP, INP_FILE, TB, TE, DT, V, N, L2N

!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER :: I, J

!-----------------------------------------------------------------------

  ALLOCATE ( V(1:N) )

  OPEN ( 11, FILE=INP_FILE, STATUS="OLD" )

  DO I = 1, N
    READ ( 11, * )  V(I)
  END DO

  CLOSE (11)

  L2N   = INT ( LOG ( REAL(N-1,DP) ) / LOG (2._DP) )

END SUBROUTINE READ_INP_DATA
