SUBROUTINE READ_INP_PARAM

  USE GLOBAL, ONLY: INP_FILE, TB, TE, DT, N, EPSILON, TYPE_D

!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER :: NT 
                                                                  
  NAMELIST /CONTROL_DATA/ INP_FILE, TB, TE, DT, NT, EPSILON, TYPE_D

!-----------------------------------------------------------------------

  TB      = 0.
  EPSILON = 0.001
  TYPE_D  = 'q'
  TE      = -9999.

  OPEN  ( 10, FILE="HFMPD", STATUS="OLD" )
  READ  ( 10, NML=CONTROL_DATA )
  CLOSE ( 10 )
 
  INP_FILE  = INP_FILE (1:LEN_TRIM(INP_FILE))//'.DAT'

  N = NT
  IF (TE == -9999.) TE = (NT-1)*DT
  
END SUBROUTINE READ_INP_PARAM

