FUNCTION D_F_W_1 ( S, FA )

  USE GLOBAL, ONLY: WP, W0, PI

  IMPLICIT NONE 

!-------------------------------------------------

  REAL(WP), PARAMETER  :: PI14 =  0.7511255444649
  REAL(WP), INTENT(IN) :: S, FA
  COMPLEX(WP)          :: D_F_W_1

!-------------------------------------------------
 
  IF (FA == 0.) THEN 
    D_F_W_1 = (0.,0.)
  ELSE
    D_F_W_1 = CMPLX( 0., (PI14* ( -(S*2.*PI*FA-W0)*S ) *              &
                      EXP( (-(S*2.*PI*FA-W0)**2) / 2.) ) )
  ENDIF

END FUNCTION D_F_W_1