FUNCTION F_W_1 ( S, FA )

  USE GLOBAL, ONLY: WP, W0, PI

  IMPLICIT NONE 

!----------------------------------------------------------------------

  REAL(WP), PARAMETER  :: PI14 =  0.7511255444649
  REAL(WP), INTENT(IN) :: S, FA
  COMPLEX(WP)          :: F_W_1

!----------------------------------------------------------------------
 
  IF (FA == 0.) THEN 
    F_W_1 = (0.,0.)
  ELSE
    F_W_1 = CMPLX(PI14*EXP( (-(S*2.*PI*FA-W0)**2) / 2.),0.)
  ENDIF

END FUNCTION F_W_1