FUNCTION F_W_2 ( S, FA )

  USE GLOBAL, ONLY: WP, W0, PI, M
  USE MSIMSL

  IMPLICIT NONE 
!----------------------------------------------------------------------

  REAL(WP), PARAMETER  :: PI14 =  0.7511255444649
  REAL(WP), INTENT(IN) :: S, FA
  COMPLEX(WP)          :: F_W_2

!----------------------------------------------------------------------
 
  IF (FA == 0.) THEN 
    F_W_2 = (0.,0.)
  ELSE
    F_W_2 = CMPLX(REAL(2**M) / SQRT(REAL(M*FAC(2*M-1)))                &
                  * (S*2.*PI*FA)**M                                    &
                  * EXP(-S*2.*PI*FA) , 0. )
  ENDIF

END FUNCTION F_W_2