MODULE  GLOBAL

  IMPLICIT NONE

!----------------------------------------------------------------------

  INTEGER, PARAMETER :: SP = SELECTED_REAL_KIND (6,30)
  INTEGER, PARAMETER :: DP = SELECTED_REAL_KIND (13,60)
  INTEGER, PARAMETER :: WP = DP

  REAL(WP), PARAMETER :: PI = 3.14159265359

!----------------------------------------------------------------------

  LOGICAL            :: K1, K2, K3, K4, KEY_LOG

  CHARACTER (LEN=3 ) :: TFA
  CHARACTER (LEN=20) :: INP_FILE, OUTo_FILE, OUTr_FILE, OUTt_FILE, OUTf_FILE

  INTEGER            :: WVLT_TYPE, M, N, OFMAX, KNFFT, NFFT, NFFT21

  REAL(WP)           :: W0, TB, TE, DT, FMIN, FMAX, PCOI,             &
                        FMINLOG, FMAXLOG


  REAL(WP)    ,DIMENSION (:),   ALLOCATABLE :: V
  REAL(WP)    ,DIMENSION (:,:), ALLOCATABLE :: FFF, TTT        
  COMPLEX(WP), DIMENSION (:),   ALLOCATABLE :: F_V, FWV, FPWV
  COMPLEX(WP), DIMENSION (:,:), ALLOCATABLE :: WV, WVT, WVD

END MODULE