SUBROUTINE WFTT (TWV)

  USE GLOBAL, ONLY: WP, F_V, OFMAX, NTW2, NTW, N, V, DT, NFFT, FWV, FMIN

  IMPLICIT NONE

  INTEGER :: I, J, JC

  COMPLEX(WP), DIMENSION(:,:), INTENT(INOUT) :: TWV

!--------------------------------------------------

  DO I = NTW2+1, N-NTW2
    FWV = 0.
    DO J = 1, NTW
      FWV(J) = V(I+J-NTW2-1) * (I+J-NTW2-2)*DT
    END DO
    FWV = FWV * F_V

    CALL FCOOLR (INT(LOG(REAL(NFFT))/LOG(2.)+0.5),FWV,-1._WP)
    JC = NINT(FMIN*NFFT*DT)+2
    TWV(I,1:OFMAX) = FWV(JC:OFMAX-1+JC)*DT
  END DO
  TWV(N+1,:) = CMPLX ( NTW2, 0. )

END SUBROUTINE WFTT