SUBROUTINE WRITE_PAR

  USE GLOBAL, ONLY: N, DT, TB, TE, OFMAX, FMIN, FMAX, TFA, WTW, &
                    V, TW_TYPE, PERC, KEY_LOG, K1, K2, K3, K4,  &
                    OUTr_FILE, OUTt_FILE, OUTf_FILE, OUTo_FILE 

  IMPLICIT NONE

!----------------------------------------------------------------

  TFA = 'WFT'
  IF ( K1 ) THEN 
    OPEN  ( 12, FILE=OUTr_FILE, FORM='UNFORMATTED',STATUS="NEW" )
    WRITE ( 12 ) TFA
    WRITE ( 12 ) WTW
    WRITE ( 12 ) TW_TYPE          

    SELECT CASE ( TW_TYPE )
      CASE (1)
        WRITE ( 12 ) PERC
    END SELECT 
   
    WRITE ( 12 ) N, DT, TB, TE, FMIN, FMAX, OFMAX, KEY_LOG
    WRITE ( 12 ) V(1:N)
  ENDIF

  IF ( K2 ) THEN
    OPEN  ( 14, FILE=OUTt_FILE, FORM='UNFORMATTED',STATUS="NEW" )
    WRITE ( 14 ) TFA
    WRITE ( 14 ) WTW
    WRITE ( 14 ) TW_TYPE

    SELECT CASE ( TW_TYPE )
      CASE (1)
        WRITE ( 14 ) PERC
    END SELECT 

    WRITE ( 14 ) N, DT, TB, TE, FMIN, FMAX, OFMAX, KEY_LOG
    WRITE ( 14 ) V(1:N)
  ENDIF

  IF ( K3 ) THEN
    OPEN  ( 15, FILE=OUTf_FILE, FORM='UNFORMATTED',STATUS="NEW" )
    WRITE ( 15 ) TFA
    WRITE ( 15 ) WTW
    WRITE ( 15 ) TW_TYPE

    SELECT CASE ( TW_TYPE )
      CASE (1)
        WRITE ( 15 ) PERC
    END SELECT 

    WRITE ( 15 ) N, DT, TB, TE, FMIN, FMAX, OFMAX, KEY_LOG
    WRITE ( 15 ) V(1:N)
  ENDIF

  IF ( K4 ) THEN
  OPEN  ( 16, FILE=OUTo_FILE, FORM='UNFORMATTED',STATUS="NEW" )
    WRITE ( 16 ) TFA
    WRITE ( 16 ) WTW
    WRITE ( 16 ) TW_TYPE

    SELECT CASE ( TW_TYPE )
      CASE (1)
        WRITE ( 16 ) PERC
    END SELECT 

    WRITE ( 16 ) N, DT, TB, TE, FMIN, FMAX, OFMAX, KEY_LOG
    WRITE ( 16 ) V(1:N)
  ENDIF

END SUBROUTINE WRITE_PAR