SUBROUTINE AXIS ( AMAX, DTICS, NDD, ND )

USE PRECISION, ONLY: WP

!----------------------------------------------------------------------

IMPLICIT NONE

  REAL (WP),         INTENT(IN   )  :: AMAX

  INTEGER,           INTENT(INOUT)  :: NDD, ND
  REAL (WP),         INTENT(INOUT)  :: DTICS

  INTEGER :: I
!  INTEGER, DIMENSION(10) ::  B
  REAL,    DIMENSION(10) ::  A, B
  REAL,    DIMENSION(1 ) ::  IDT


!----------------------------------------------------------------------
  
  IF ( DTICS < 1. ) THEN
!    DTICS = ANINT( (DTICS/10**(FLOOR( LOG10(DTICS) )- 1._WP)) ) * 10**(FLOOR( LOG10(DTICS) )-1._WP)
!    NDD = ABS (FLOOR( LOG10(DTICS) ))+1
!    IF ( AMAX < 10.) THEN
!       ND = NDD + 1 + 1    ! plus dec.point plus number of nondec.digits ( = order + 1)
!    ELSE
!       ND = NDD + 1 + CEILING( LOG10(AMAX) ) 
!    ENDIF
!    IDTICS = IDNINT(DTICS)  !real*8 -> integer*4 - zaokruhli to
    A(1)  =  1.
    A(2)  =  0.5
    A(3)  =  0.25
    A(4)  =  0.2
    A(5)  =  0.125
    A(6)  =  0.1
    A(7)  =  0.05
    A(8)  =  0.025
    A(9)  =  0.01
    A(10) =  0.001 
    DO I = 1,10
      B(I) = ABS(DTICS - A(I))
    ENDDO
    IDT   = A( MINLOC(B(:)) ) 
    DTICS = IDT(1)
    NDD   = ABS (FLOOR( LOG10(DTICS) ))
    ND    = CEILING( LOG10(AMAX) )+1 + NDD + 1
  ELSE
!    IDTICS = IDNINT(DTICS)  !real*8 -> integer*4 - zaokruhli to
    A(1)  =    1.
    A(2)  =    5.
    A(3)  =   10.
    A(4)  =   20.
    A(5)  =   25.
    A(6)  =   50.
    A(7)  =  100.
    A(8)  =  250.
    A(9)  =  500.
    A(10) = 1000. 
    DO I = 1,10
      B(I) = ABS(DTICS - A(I))
    ENDDO
    IDT   = A( MINLOC(B(:)) ) 
    DTICS = IDT(1)
    NDD   = 0
    ND    = CEILING( LOG10(AMAX) )+1
  ENDIF
END SUBROUTINE AXIS
