MODULE MOD_BMP

INTERFACE

	SUBROUTINE BMP( INPUT, BMP_FILE, DES_FILE )
		INTEGER, DIMENSION(:,:) :: INPUT
    CHARACTER*12            :: DES_FILE
		CHARACTER*15            :: BMP_FILE
	END SUBROUTINE

!-----------------------------------------------------------------------

	FUNCTION U_BYTE(B)
		INTEGER :: B
		BYTE    :: U_BYTE
	END FUNCTION

	FUNCTION U_INT2(I)
		INTEGER(4) :: I
		INTEGER(2) :: U_INT2
	END FUNCTION

	FUNCTION U_INT4(I)
		DOUBLE PRECISION :: I
		INTEGER          :: U_INT4
	END FUNCTION

!-----------------------------------------------------------------------

	FUNCTION S_INT2(I)
		INTEGER(2) :: I
		INTEGER(4) :: S_INT2
	END FUNCTION

	FUNCTION S_INT4(I)
		INTEGER :: I
		DOUBLE PRECISION :: S_INT4
	END FUNCTION

!-----------------------------------------------------------------------

  FUNCTION B4_B(B4)
    INTEGER               :: B4
    INTEGER, DIMENSION(4) :: B4_B
  END FUNCTION

  INTEGER(4) FUNCTION B_B4(B1,B2,B3,B4)
    INTEGER :: B1, B2, B3, B4
  END FUNCTION

  FUNCTION B2_B(B2)
    INTEGER(2)            :: B2
    INTEGER, DIMENSION(2) :: B2_B
  END FUNCTION

  INTEGER(2) FUNCTION B_B2(B1,B2)
    INTEGER :: B1, B2
  END FUNCTION

!-----------------------------------------------------------------------

	SUBROUTINE SET_PALETTE( DES_FILE, PALETTE )
		CHARACTER*12      :: DES_FILE
		INTEGER(2), INTENT(OUT) :: PALETTE(256,4)
	END SUBROUTINE

!-----------------------------------------------------------------------

END INTERFACE

END MODULE