SUBROUTINE TEST_BORDERS ( P, LMIN, LMAX, GMIN, GMAX, KEY_LOG)

USE PRECISION, ONLY: WP

!----------------------------------------------------------------------

IMPLICIT NONE

  CHARACTER (1),     INTENT(IN)     :: P
  LOGICAL,           INTENT(IN)     :: KEY_LOG
  REAL (WP),         INTENT(IN)     :: GMIN, GMAX
  REAL (WP),         INTENT(INOUT)  :: LMIN, LMAX

!----------------------------------------------------------------------

  IF ( (KEY_LOG) .AND. (P =='F') ) THEN

    IF  (LMIN < GMIN) THEN
      LMAX = 10 ** ( LOG10(LMAX/LMIN) + LOG10(GMIN) )
      LMIN =        GMIN
    ENDIF
    IF  (LMAX > GMAX) THEN
      LMIN = 10 ** ( LOG10(LMIN/LMAX) + LOG10(GMAX) )
      LMAX =               GMAX
    ENDIF
    IF ( ( LMAX - LMIN ) > ( GMAX - GMIN ) ) THEN
      LMIN = GMIN
      LMAX = GMAX
    END IF

  ELSE

    IF ( ( LMAX - LMIN ) > ( GMAX - GMIN ) ) THEN
      LMIN = GMIN
      LMAX = GMAX
    END IF
    IF  (LMIN < GMIN) THEN
      LMAX = LMAX + GMIN - LMIN
      LMIN =        GMIN
    ENDIF
    IF  (LMAX > GMAX) THEN
      LMIN = LMIN - LMAX + GMAX
      LMAX =               GMAX
    ENDIF

  ENDIF

END SUBROUTINE TEST_BORDERS